if ('undefined' == typeof(MailSleuth)) {
    var MailSleuth = {
        b3PaneWindow: false,
        strCode: "9TepJMdmBeEWMA/aMSNuaj+g",
        cstrAddressee: "trace-request@mailsleuthonline.com",
        InboxFolder: nsMsgFolderFlags.Inbox,
        onLoad: function onLoad() {
            this.Dump("onLoad - entry");
            this.b3PaneWindow = document.documentElement.getAttribute("windowtype") == "mail:3pane";
            var contextMenu = document.getElementById("mailContext");
            if (contextMenu) contextMenu.addEventListener("popupshowing", function(e) {MailSleuth.onContextMenuPopup(e);}, false);
            this.Dump("onLoad - exit");
        },
        onSleuthItCommand: function() {
            this.Dump("onSleuthItCommand - entry");
            if (!gDBView || gDBView.numSelected == 0 )
                return;
            var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService().QueryInterface(Components.interfaces.nsIMsgComposeService);
            var length = {};    
            var messageArray = gDBView.getURIsForSelection(length);

            for (var i = 0; i < length.value; ++i) {
                var msgFields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
                var msgParams = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
                var messageUri = messageArray[i];
                msgFields.body = this.GetHeaders(messageUri);
                msgFields.subject = this.strCode;
                msgFields.to = MailSleuth.cstrAddressee;
                msgFields.bodyIsAsciiOnly = true;
                msgParams.composeFields = msgFields;
                msgParams.format = Components.interfaces.nsIMsgCompFormat.PlainText;
                msgParams.type = Components.interfaces.nsIMsgCompType.New;
                msgComposeService.OpenComposeWindowWithParams(null,msgParams);
            }
            this.Dump("onSleuthItCommand - exit");
        },
        onContextMenuPopup: function(event) {
            this.Dump("onContextMenuPopup - entry");
            var btn = document.getElementById("mailsleuth-SleuthIt");
            if(! btn) {
                return;
            }
            var ctx = new nsContextMenu(event.target);
                if (!ctx.inThreadPane){
                btn.hidden = true;
                return;
            }
            if ((!this.b3PaneWindow) || (!gDBView) || (gDBView.numSelected == 0)){
                btn.hidden = true;
                return;
            }
            var startIndex = {};
            var endIndex = {};
            gFolderTreeView.selection.getRangeAt(0, startIndex, endIndex);
            if (startIndex.value < 0) {
                btn.hidden = true;
                return;
            }
            var numSelected = endIndex.value - startIndex.value + 1;	
            var folderResource = gFolderTreeView.getSelectedFolders()[0];
            if (numSelected == 0 ) {
                btn.hidden = true;
                return;
            }
            if (folderResource.isSpecialFolder(MailSleuth.InboxFolder, true) && numSelected == 1 ) {
                btn.hidden = false;
            } else {
                btn.hidden = true;
            }
            return true;
        },
        Dump: function (aMessage) {
        //return;
        var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
        consoleService.logStringMessage("MailSleuth: " + aMessage);
        },
        GetHeaders: function GetHeaders(messageURI) {
            var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger);
            var messageService = messenger.messageServiceFromURI(messageURI);
            var messageStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance(Components.interfaces.nsIInputStream);
            var inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
            inputStream.init(messageStream);
            try {
                messageService.streamMessage(messageURI,messageStream, null, null, false, null);
            } catch (ex) {return null;}

            var headers = "";
            try {
                inputStream.available();
            } catch(e){}
            while (inputStream.available()) {
                headers = headers + inputStream.read(512);
                var p = headers.indexOf("\r\n\r\n");
                if (p < 0)
                    p = headers.indexOf("\n\n");
                if (p > 0) {
                    headers = headers.substring(0, p);
                    break;
                }
            }
            var aMessageHeader = messenger.messageServiceFromURI(messageURI).messageURIToMsgHdr(messageURI); 
            var listener = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance(Components.interfaces.nsISyncStreamListener);
            var uri = aMessageHeader.folder.getUriForMsg(aMessageHeader);
            messenger.messageServiceFromURI(uri).streamMessage(uri, listener, null, null, false, "");
            var folder = aMessageHeader.folder;
            var body = folder.getMsgTextFromStream(listener.inputStream, aMessageHeader.Charset, 65536, 32768, false, true, { });
            try {
                headers = this.RemoveHeader(headers, "From -");
                headers = this.RemoveHeader(headers, "X-Mozilla-Status");
                headers = this.RemoveHeader(headers, "X-Mozilla-Status");
            } catch(e) {}
            return "Header Start\r\n\r\n" + headers + "\r\n\r\nHeader End\r\n\r\n" + body;
        },
        IndexOfCRLFOrCR: function(str) {
            var p = str.indexOf("\r\n");
            if ( p >= 0 )
                return p +2;
            else if ( (p = str.indexOf("\n")) >=0 )
                return p+1;
            return -1;
        },
        RemoveHeader: function (headers, hdr) {
            var p = headers.indexOf(hdr);
            if ( p == 0 ) {
                p = this.IndexOfCRLFOrCR(headers);
                if ( p >= 0 )
                    headers = headers.substring(p,headers.length);
            }
            return headers;
        }
    };
}

window.addEventListener("load", function(e) {MailSleuth.onLoad(e);}, false);